/*
 * crc32.c
 *
 *  Created on: 27.04.2009
 *      Author: Alexander Boldyrev
 */

unsigned long crc32(unsigned char *buffer, unsigned long length) {
	unsigned long crc_table[256];
	unsigned long crc;
	int i;

	for (i = 0; i < 256; i++) {
		int j;
		crc = i;
		for (j = 0; j < 8; j++)
			crc = crc & 1 ? (crc >> 1) ^ 0xEDB88320UL : crc >> 1;

		crc_table[i] = crc;
	};

	crc = 0xFFFFFFFFUL;

	while (length--)
		crc = crc_table[(crc ^ *buffer++) & 0xFF] ^ (crc >> 8);

	return crc ^ 0xFFFFFFFFUL;
}
;
